Crystal::Macros::ArrayLiteral - Crystal 0.35.1

# class Crystal::Macros::ArrayLiteral

- Crystal::Macros::ArrayLiteral
- Crystal::Macros::ASTNode
- Reference
- Object

##
Overview

An array literal.

##
Defined in:

##
Instance Method Summary

- #+(other : ArrayLiteral) : ArrayLiteral

  Similar to `Array#+`.

- #<<(value : ASTNode) : ArrayLiteral

  Similar to `Array#<<`.

- #[](index : NumberLiteral) : ASTNode

  Similar to `Array#[]`, but returns `NilLiteral` on out of bounds.

- #[]=(index : NumberLiteral, value : ASTNode)

  Similar to `Array#[]=`.

- #all?(&) : BoolLiteral

  Similar to `Enumerable#all?`

- #any?(&) : BoolLiteral

  Similar to `Enumerable#any?`

- #clear : ArrayLiteral

  Similar to `Array#clear`

- #each(&) : Nil

  Similar to `Array#each`

- #each_with_index(&) : Nil

  Similar to `Enumerable#each_with_index`

- #empty? : BoolLiteral

  Similar to `Array#empty?`

- #find(&) : ASTNode | NilLiteral

  Similar to `Enumerable#find`

- #first : ASTNode | NilLiteral

  Similar to `Array#first`, but returns a `NilLiteral` if the array is empty.

- #includes?(node : ASTNode) : BoolLiteral

  Similar to `Enumerable#includes?(obj)`.

- #join(separator) : StringLiteral

  Similar to `Enumerable#join`

- #last : ASTNode | NilLiteral

  Similar to `Array#last`, but returns a `NilLiteral` if the array is empty.

- #map(&) : ArrayLiteral

  Similar to `Enumerable#map`

- #map_with_index(&) : ArrayLiteral

  Similar to `Enumerable#map_with_index`

- #of : ASTNode | Nop

  Returns the type specified at the end of the array literal, if any.

- #push(value : ASTNode) : ArrayLiteral

  Similar to `Array#push`.

- #reduce(memo : ASTNode, &) : ASTNode

  Similar to `Enumerable#reduce`

- #reduce(&) : ASTNode

  Similar to `Enumerable#reduce`

- #reject(&) : ArrayLiteral

  Similar to `Enumerable#reject`

- #select(&) : ArrayLiteral

  Similar to `Enumerable#select`

- #shuffle : ArrayLiteral

  Similar to `Array#shuffle`

- #size : NumberLiteral

  Similar to `Array#size`

- #sort : ArrayLiteral

  Similar to `Array#sort`

- #sort_by(&) : ArrayLiteral

  Similar to `Array#sort_by`

- #splat(trailing_string : StringLiteral = nil) : MacroId

  Returns a `MacroId` with all of this array's elements joined by commas.

- #type : Path | Nop

  Returns the type that receives the items of the array.

- #uniq : ArrayLiteral

  Similar to `Array#uniq`

- #unshift(value : ASTNode) : ArrayLiteral

  Similar to `Array#unshift`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, line_number : StringLiteral | NilLiteral line_number, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(*values : Object) : Bool
in?(collection) : Bool in?, inspect : String
inspect(io : IO) : Nil inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(io : IO, indent : String = " ")
to_pretty_json(indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Instance Method Detail

def +(other : ArrayLiteral) : ArrayLiteral #

Similar to `Array#+`.

def <<(value : ASTNode) : ArrayLiteral #

Similar to `Array#<<`.

def [](index : NumberLiteral) : ASTNode #

Similar to `Array#[]`, but returns `NilLiteral` on out of bounds.

def []=(index : NumberLiteral, value : ASTNode) #

Similar to `Array#[]=`.

def all?(&) : BoolLiteral #

Similar to `Enumerable#all?`

def any?(&) : BoolLiteral #

Similar to `Enumerable#any?`

def clear : ArrayLiteral #

Similar to `Array#clear`

def each(&) : Nil #

Similar to `Array#each`

def each_with_index(&) : Nil #

Similar to `Enumerable#each_with_index`

def empty? : BoolLiteral #

Similar to `Array#empty?`

def find(&) : ASTNode | NilLiteral #

Similar to `Enumerable#find`

def first : ASTNode | NilLiteral #

Similar to `Array#first`, but returns a `NilLiteral` if the array is empty.

def includes?(node : ASTNode) : BoolLiteral #

Similar to `Enumerable#includes?(obj)`.

def join(separator) : StringLiteral #

Similar to `Enumerable#join`

def last : ASTNode | NilLiteral #

Similar to `Array#last`, but returns a `NilLiteral` if the array is empty.

def map(&) : ArrayLiteral #

Similar to `Enumerable#map`

def map_with_index(&) : ArrayLiteral #

Similar to `Enumerable#map_with_index`

def of : ASTNode | Nop #

Returns the type specified at the end of the array literal, if any.

This refers to the part after brackets in `[] of String`.

def push(value : ASTNode) : ArrayLiteral #

Similar to `Array#push`.

def reduce(memo : ASTNode, &) : ASTNode #

Similar to `Enumerable#reduce`

def reduce(&) : ASTNode #

Similar to `Enumerable#reduce`

def reject(&) : ArrayLiteral #

Similar to `Enumerable#reject`

def select(&) : ArrayLiteral #

Similar to `Enumerable#select`

def shuffle : ArrayLiteral #

Similar to `Array#shuffle`

def size : NumberLiteral #

Similar to `Array#size`

def sort : ArrayLiteral #

Similar to `Array#sort`

def sort_by(&) : ArrayLiteral #

Similar to `Array#sort_by`

def splat(trailing_string : StringLiteral = nil) : MacroId #

Returns a `MacroId` with all of this array's elements joined by commas.

If trailing_string is given, it will be appended to the result unless this array is empty. This lets you splat an array and optionally write a trailing comma if needed.

def type : Path | Nop #

Returns the type that receives the items of the array.

This refers to the part before brackets in `MyArray{1, 2, 3}`

def uniq : ArrayLiteral #

Similar to `Array#uniq`

def unshift(value : ASTNode) : ArrayLiteral #

Similar to `Array#unshift`.